/*----------------------------------------------------------------------------------
*
* COPYRIGHT (c) 2001 by Singing Electrons, Inc. All rights reserved.
*
*
* Module Name			: C:\se\adi\hidclass\Source\MSClass.h
*
* Description			: Contains prototypes and definitions for the Mass Storage Class implementation
*
*
* Revision History	: At bottom of the file.
*
*---------------------------------------------------------------------------------*/
#ifndef _MSCLASS_H
#define _MSCLASS_H

#define USBMS_CLASS 0x08

#define USBMS_SUBCLASS_RBC 0x01
#define USBMS_SUBCLASS_SFF8020I_OR_MMC2_ATAPI 0x02
#define USBMS_SUBCLASS_QIC_157 0x03
#define USBMS_SUBCLASS_UFI 0x04
#define USBMS_SUBCLASS_SFF8070I 0x05
#define USBMS_SUBCLASS_SCSI_TRANSPARENT 0x06

#define USBMS_INTERFACE_PROTOCOL_CBI_WITHCOMPLETIONINTERRUPT 0x00
#define USBMS_INTERFACE_PROTOCOL_CBI_WITHOUTCOMPLETIONINTERRUPT 0x01
#define USBMS_INTERFACE_PROTOCOL_BULKONLY 0x50

#define USBMS_REQUEST_RESET 0xff
#define USBMS_REQUEST_GET_MAX_LUN 0xfe

#define CBW_LENGTH 0x1f
#define CBW_SIGNATURE 0x43425355
#define CBW_SIGNATURE_OFFSET 0
#define CBW_SIGNATURE_LEN 4
#define CBW_TAG_OFFSET 4
#define CBW_TAG_LEN 4
#define CBW_DATA_TRANSFER_LENGTH_OFFSET 8
#define CBW_DATA_TRANSFER_LENGTH_LEN 4
#define CBW_FLAGS_OFFSET 12
#define CBW_FLAGS_LEN 1
#define CBW_LUN_OFFSET 13
#define CBW_LUN_LEN 1
#define CBW_WCBLENGTH_OFFSET 14
#define CBW_WCBLENGTH_LEN 1
#define CBW_WCB_OFFSET 15
#define CBW_WCB_LEN 16

	
#define CDW_FLAG_DATA_FROM_DEVICE_TO_HOST 0x80


#define CSW_LENGTH 0x0d
#define CSW_SIGNATURE 0x53425355
#define CSW_SIGNATURE_OFFSET 0
#define CSW_SIGNATURE_LEN 4
#define CSW_TAG_OFFSET 4
#define CSW_TAG_LEN 4
#define CSW_DATA_RESIDUE_OFFSET 8
#define CSW_DATA_RESIDUE_LEN 4
#define CSW_STATUS_OFFSET 12
#define CSW_STATUS_LEN 1


#define CSW_STATUS_COMMAND_PASSED 0x00
#define CSW_STATUS_COMMAND_FAILED 0x01
#define CSW_STATUS_COMMAND_PHASE_ERROR 0x02

bool MSCLASS_Init (uint16 vid, uint16 pid, uint16 rel, PSUSPENDPROC pOnSuspendProc, 
	PRESUMEPROC pOnResumeProc, PRESETPROC pOnResetProc);

extern bool gIsTransferActive;

#endif //end of _MSCLASS_H

/*----------------------------------------------------------------------------------
* $Log: MSClass.h,v $
* Revision 1.1  2003/03/03 18:13:45  Devendra
* First Rev, the device enumerates as Mass Storage Class
*
*
*---------------------------------------------------------------------------------*/
